2002-11-10  John Harper  <jsh@unfactored.org>

	* shell.jl (add-active-slots): new function, used to add slots
	into the active-slots list. Ensures that slots aren't added
	more than once (which was the cause of #88718 and other similar
	bugs)

2002-11-09  John Harper  <jsh@unfactored.org>

	* version 1.2

2002-11-03  John Harper  <jsh@unfactored.org>

	* widgets/match-window.jl, widgets/keymap.jl: 

	* shell.jl, widgets/match-window.jl, widgets/keymap.jl: some
	small UI tweaks

2002-11-02  John Harper  <jsh@unfactored.org>

	* widgets/keymap.jl (make-keymap:binding-item): fix packing of
	"Grab" button

	* widgets/command.jl (make-command-item): set minimum size of
	text and clist widgets

2002-05-29  John Harper  <jsh@unfactored.org>

	* more merging:

	2002-05-29  John Harper  <jsh@unfactored.org>

	* widgets/frame-style.jl (make-frame-style-item): added a 200ms
	delay before installing new themes, avoids overloading X when
	dragging over the combo box menu. Should fix #81723

2002-05-21  John Harper  <jsh@unfactored.org>

	* Merged changes from HEAD:

	2002-05-06  John Harper  <jsh@unfactored.org>

	* i18n.jl: patch from Christophe Fergeau
	<teuf@users.sourceforge.net> to call bindtextdomaincodeset
	function. Modified to only call it if it exists

2002-04-21  John Harper  <jsh@unfactored.org>

	* Merged changes from HEAD:

	2002-04-20  John Harper  <jsh@unfactored.org>

	Removed user levels, button configuration:

	* wm.jl, user-level.jl, slot.jl, shell.jl, main.jl.in,
	apply.jl, Makefile.in: 

	* widgets/command.jl: 

	2002-04-18  John Harper  <jsh@unfactored.org>

	* widgets/match-window.jl: use optional scheme-boolean widgets
	to display booleans. Adapted from merlin <merlin@merlin.org>

2002-04-01  John Harper  <jsh@unfactored.org>

	* shell.jl, group.jl, layouts/keymaps.jl,
	widgets/match-window.jl, widgets/icon.jl,
	widgets/frame-style.jl, widgets/event.jl, widgets/command.jl:
	s/gtk-signal-/g-signal-/

2002-03-03  John Harper  <jsh@pixelslut.com>

	* shell.jl: display using a tree of notebook pages for now

	* widgets/frame-style.jl (make-frame-style-item): removed
	debugging spew

2002-02-13  John Harper  <jsh@unfactored.org>

	* widgets/frame-style.jl (make-frame-style-item): go to great
	lengths to avoid picking up fucked changes from the combo's
	entry widget

2002-02-12  John Harper  <jsh@unfactored.org>

	* slot.jl, shell.jl, main.jl.in, layout.jl, group.jl: 
	* layouts/keymaps.jl: 
	* widgets/match-window.jl, widgets/keymap.jl,
	widgets/frame-style.jl, widgets/command.jl: 

	Ported to current gnome2 rep-gtk

2002-01-29  John Harper  <jsh@unfactored.org>

	* slot.jl, shell.jl, layout.jl, group.jl, apply.jl: 
	* layouts/keymaps.jl: 
	* widgets/workspace-geometry.jl, widgets/match-window.jl,
	widgets/keymap.jl, widgets/icon.jl, widgets/frame-style.jl,
	widgets/event.jl, widgets/command.jl: 

	Changed module names for gnome2 rep-gtk

2001-09-07  John Harper  <jsh@pixelslut.com>

	* layouts/keymaps.jl (layout-keymaps): fixed bug of keymap
	popup menu being displayed even if there are no keymaps to
	configure

	* shell.jl (display-flattened): fixed bug of `--flatten
	--single-level' combination not working properly

2001-08-23  John Harper  <jsh@pixelslut.com>

	* widgets/match-window.jl (make-match-window:matchers): search
	the translated X properties for the real atom name when
	grabbing properties, don't pass the (translated) property name

2001-07-02  John Harper  <jsh@pixelslut.com>

	* version 0.99

2001-04-20  John Harper  <jsh@eazel.com>

	Extra i18n work. Adapted from a patch by Vlad Harchev
	<hvv@hippo.ru>

	* layouts/keymaps.jl (beautify-keymap-name): try to localize
	the name before returning it
	* widgets/keymap.jl (beautify-symbol-name): ditto
	* widgets/match-window.jl (beautify-symbol-name): ditto

	* widgets/match-window.jl (make-match-window:matchers):
	localizes all property names before starting, then uses that
	list of properties

2001-02-13  John Harper  <jsh@eazel.com>

	* version 0.37

2001-02-07  John Harper  <jsh@eazel.com>

	* widgets/event.jl (make-event-item): strip leading and
	trailing white space from the event name in the `ref' method

2001-01-27  John Harper  <jsh@eazel.com>

	* shell.jl (display-flattened-group): translate the real name
	of the group before making it the title of the notebook page

2001-01-05  John Harper  <jsh@eazel.com>

	* version 0.35

2000-12-18  John Harper  <jsh@eazel.com>

	* widgets/modifier-list.jl (validp): don't allow () as a valid
	modifier list

2000-12-04  John Harper  <jsh@eazel.com>

	* version 0.34

2000-11-28  John Harper  <jsh@eazel.com>

	* widgets/modifier-list.jl: new widget, manages a list of
	modifier key names

	* layouts/keymaps.jl: only put slots whose names end in
	`-keymap' into the popup menu, just stack any others in the
	vbox

	* shell.jl (display-flattened): if the layout widget is a
	container, give it a non-zero border-width

2000-11-27  John Harper  <jsh@eazel.com>

	* widgets/frame-style.jl (make-frame-style-item): reversed
	order of combo box and label; don't set usize of text box

	* layout.jl: renamed `expand' flag as `expand-vertically';
	added an `expand-horizontally' flag; changed `framed' flag to
	use a vbox instead of a frame widget

2000-11-21  John Harper  <jsh@eazel.com>

	* layout.jl (layout-box): don't set the border of the box
	(document-slot): when checking whether a doc string is given or
	not, also check if the value is the null string

	* widgets/command.jl (update-params): when ref'ing commands
	without arguments, remember to use command-name to remove any
	keywords in the command definition. Fixes #4827

2000-11-17  John Harper  <jsh@eazel.com>

	* main.jl.in: don't initialize backtrace-on-error

2000-11-16  John Harper  <jsh@eazel.com>

	* slot.jl: added a `flags' field to the slot structure, used to
	store flags for when displaying widgets

	* layout.jl: check slot-flags, handle `expand' and `framed'

	* wm.jl (wm-locale-dir): dereference sawfish-locale-directory
	on the remote side, instead of using bindtextdomain

2000-11-14  John Harper  <jsh@eazel.com>

	* widgets/workspace-geometry.jl (monitor-pixbuf-file): search
	load-path for the `../monitor.png' file, instead of just
	assuming that it's relative to the first item of the list

2000-11-08  John Harper  <jsh@eazel.com>

	* version 0.33

2000-11-06  John Harper  <jsh@eazel.com>

	* group.jl, shell.jl: fixed some bugs introduced by the change
	to refresh groups after slot commits

2000-11-02  John Harper  <jsh@eazel.com>

	* group.jl (fetch-group, select-group): added keyword parameter
	FORCE that overrides certain checks

	(refresh-groups-for-slots): new exported function; given a list
	of slots it will resync any groups that contain any of these
	slots

	* apply.jl (do-apply): call refresh-groups-for-slots after
	committing any changes

2000-11-01  John Harper  <jsh@eazel.com>

	* group.jl: some internal reorganization (may help reloading
	group info..)

2000-10-26  John Harper  <jsh@eazel.com>

	* widgets/command.jl: now supports #:user-level's in commands

2000-10-20  John Harper  <jsh@eazel.com>

	* widgets/command.jl: support (but currently ignore)
	user-levels associated with commands

	* user-level.jl (user-level-is-appropriate-p): new function

2000-10-10  John Harper  <john@dcs.warwick.ac.uk>

	* apply.jl (apply-changes-for): catch errors from
	wm-apply-changes and display them in a dialog after reverting
	the changed slots

2000-09-25  John Harper  <john@dcs.warwick.ac.uk>

	* widgets/keymap.jl (make-keymap:binding-item): add a `Key:'
	label to the event widget

	* widgets/event.jl (make-event-item): don't prefix the widget
	with a `Key:' label, it's more useful without it

	* layout.jl (document-slot): handle adding any tooltip embedded
	in the slots documentation string

2000-09-20  John Harper  <john@dcs.warwick.ac.uk>

	* version 0.31

2000-09-12  John Harper  <john@dcs.warwick.ac.uk>

	* shell.jl (initialize-shell): unless creating a plug, put the
	root widget inside a raised frame

2000-09-11  John Harper  <john@dcs.warwick.ac.uk>

	* slot.jl, shell.jl, main.jl.in, group.jl, ChangeLog: 
	* layouts/keymaps.jl: 
	* widgets/match-window.jl, widgets/keymap.jl,
	widgets/frame-style.jl, widgets/command.jl: 

	No need to explicitly open `rep.io.streams' anymore

2000-09-08  John Harper  <john@dcs.warwick.ac.uk>

	* slot.jl, shell.jl, main.jl.in, layout.jl, i18n.jl, group.jl,
	apply.jl: 

	* layouts/keymaps.jl: 

	* widgets/workspace-geometry.jl, widgets/match-window.jl,
	widgets/keymap.jl, widgets/icon.jl, widgets/frame-style.jl,
	widgets/command.jl: 

	Open the necessary modules that aren't included in `rep'
	structure anymore (rep.regexp, rep.system, rep.io.streams,
	rep.io.files, rep.io.file-handlers)

2000-09-04  John Harper  <john@dcs.warwick.ac.uk>

	* main.jl.in: /bin/sh on solaris 8 doesn't like to pass
	environment settings on the same line as exec stmts. So set
	REP_LOAD_PATH, export it, then run `rep'

	* wm.jl (wm-documentation): use the `command-documentation'
	function

2000-09-02  John Harper  <john@dcs.warwick.ac.uk>

	* group.jl (update-group): ':layout is now #:layout

	* slot.jl (make-slot): use keyword params
	(fetch-group): removed unused first arg

2000-09-01  John Harper  <john@dcs.warwick.ac.uk>

	* wm.jl, user-level.jl, slot.jl, shell.jl, main.jl.in,
	layout.jl, i18n.jl, group.jl, config.jl, apply.jl: 

	* layouts/keymaps.jl: 

	* widgets/workspace-geometry.jl, widgets/match-window.jl,
	widgets/keymap.jl, widgets/icon.jl, widgets/frame-style.jl,
	widgets/event.jl, widgets/command.jl: 

	Moved to `sawfish.ui' branch of the module namespace

	* widgets/gtk/workspace-geometry.jl, widgets/gtk/icon.jl: GTK+
	only versions of widgets that normally require GNOME

2000-08-21  John Harper  <john@dcs.warwick.ac.uk>

       * nokogiri-shell.jl: connect to delete_event from capplet
       again; but connect to a function that returns t (to avoid
       destroying the widget) and sets a 10-second timeout to call
       on-quit

2000-08-16  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-widgets/icon.jl: fixed bug in 'set method when
	called with false argument

2000-08-16  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-wm.jl, nokogiri-widget.jl, nokogiri-widget-test.jl,
	nokogiri-widget-dialog.jl, nokogiri-shell.jl,
	nokogiri-no-gnome.jl, nokogiri-gnome.jl,
	nokogiri-widgets/workspace-geometry.jl,
	nokogiri-widgets/pair.jl, nokogiri-widgets/match-window.jl,
	nokogiri-widgets/list.jl, nokogiri-widgets/keymap.jl,
	nokogiri-widgets/alist.jl: 

	use #!optional and #!rest instead of deprecated &optional and
	&rest

2000-08-14  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-shell.jl (initialize-shell): only hook to
	`delete_event' signal if window isn't a plug (avoids race
	condition found by Havoc Pennington)

2000-08-03  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-widget.jl (make-number-item): added backwards
	compatibility for (eq min/max 'nil)

2000-07-31  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-widgets/list.jl: changed the buttons to be `delete,
	edit, add', not `delete, edit, insert'. `Add' inserts after the
	current selection, this behaves more sanely when adding a
	sequence of values

2000-07-30  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-main.jl.in: handle --help option

2000-07-27  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-wm.jl: use sawfish.client plugin instead of calling
	external program

2000-07-24  John Harper  <john@dcs.warwick.ac.uk>

	* version 0.30.3

2000-07-23  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-widgets/font.jl: fix structure name in definition

	* nokogiri-widgets/match-window.jl (print-matcher): be more
	cautious, reports of broken input

2000-07-14  John Harper  <john@dcs.warwick.ac.uk>

	* version 0.30.2

2000-07-11  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-no-gnome.jl, nokogiri-widgets/workspace-geometry.jl:
	use `Rows' and `Columns' as labels instead of `Y' and `X'

	* nokogiri-no-gnome.jl (workspace-geometry): fixed bug of not
	including `number' widget for number of workspaces

2000-07-09  John Harper  <john@dcs.warwick.ac.uk>

	* version 0.30

	* nokogiri-widget-dialog.jl: put the title above the widget,
	not beside it

	* nokogiri-widget.jl: new widget type `quoted'

2000-07-08  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-widgets/pair.jl (make-pair-item): added optional arg
	REVERSED, when non-nil, the layout order of the widgets is
	swapped

	* nokogiri-widgets/event.jl, nokogiri-widgets/command.jl:
	factored these out of the `keymap' widget, since they may be of
	use individually

2000-07-07  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-widgets/list.jl: set the clist to `browse' mode, and
	keep it frozen while modifying it

	* nokogiri-widgets/list.jl (edit-item): save the original value
	of the selection, since it may get changed asynchronously

2000-07-06  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-widget.jl (list-index): made this function terminate
	even if the item isn't in the list!

	* nokogiri-no-gnome.jl, nokogiri-gnome.jl (simple-dialog): new
	function, replaces ok-cancel-dialog, uses GnomeDialog if possible
	* nokogiri-dialog.jl: deleted

	* nokogiri-widget-dialog.jl (widget-dialog): use simple-dialog,
	new optional arg MAIN_WINDOW

	* nokogiri-widgets/match-window.jl, nokogiri-widgets/list.jl,
	nokogiri-widgets/keymap.jl, nokogiri-widgets/alist.jl: updated
	to use simple-dialog and new widget-dialog arg

	* nokogiri-widgets/list.jl: make the `insert' button insert
	instead of appending, make `delete' preserve the selection,
	only allow `delete' or `edit' when the selection is set

2000-07-05  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-interfaces.jl.in (*nokogiri-directory*): new special
	variable

	* monitor.png: install this locally instead of relying on GNOME
	version
	* nokogiri-widgets/workspace-geometry.jl (monitor-pixbuf): use
	the local version

	* Makefile.in: support GNOME and non-GNOME installations

	* nokogiri-widgets/workspace-geometry.jl: new widget, uses
	GNOME canvas to draw workspace/viewport representation

	* nokogiri-widgets/pair.jl: new optional arg, USE-VBOX

	* nokogiri-widgets/icon.jl: new widget, mostly from Bruce
	Miller <docmad@md.prestige.net>

	* nokogiri-widgets/frame-style.jl: accepts a doc string

	* nokogiri-widget-test.jl (test-widget): added optional arg
	INITIAL-VALUE

	* nokogiri-no-gnome.jl, nokogiri-gnome.jl: new files

	* nokogiri-interfaces.jl.in: contains all module interfaces

	* nokogiri-wm.jl, nokogiri-widget.jl,
	nokogiri-widget-dialog.jl, nokogiri-user-level.jl,
	nokogiri-slot.jl, nokogiri-shell.jl, nokogiri-layout.jl,
	nokogiri-i18n.jl, nokogiri-group.jl, nokogiri-dialog.jl,
	nokogiri-config.jl, nokogiri-color-preview.jl,
	nokogiri-apply.jl: moved module interfaces to
	nokogiri-interfaces.jl.in

	* nokogiri-widget.jl (widget-accepts-doc-string,
	widget-accepts-doc-string-p): functions to allow passing of doc
	strings to widgets

	* nokogiri-dialog.jl: use stock-button, don't grab the window
	(e.g. it breaks GnomeIconEntry)

	* nokogiri-shell.jl (initialize-shell): use stock-button to
	create buttons

	* nokogiri-slot.jl (make-slot-widget): pass doc strings to
	widgets that accept them

2000-07-03  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-group.jl (make-group-tree): translate real-name

2000-07-02  John Harper  <john@dcs.warwick.ac.uk>

	* version 0.29

2000-07-01  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-shell.jl (*nokogiri-single-level*): new defvar
	* nokogiri-main.jl.in: new option, --single-level

	* nokogiri-widgets/keymap.jl: set the documentation widget
	uneditable

	* nokogiri-widgets/frame-style.jl: use a GtkText widget to
	display the theme README

	* nokogiri-apply.jl (revert-slot-changes): when updating widget
	values, call update-dependences on the slot

	* nokogiri-shell.jl (initialize-shell): when possible, use
	gtk-window-set-default-size instead of gtk-widget-set-usize

	* nokogiri-dialog.jl: set the TRANSIENT_FOR hint of the dialog
	when the necessary Gtk+ function is available

	* nokogiri-widgets/keymap.jl: support commands with arguments

	* nokogiri-wm.jl (wm-command-list): use nokogiri-report-commands
	(wm-documentation): require `lisp-doc' on server-side

	* nokogiri-widget.jl: removed all setting of borders from
	widgets
	(labelled): move the label to the left of the widget

	* nokogiri-dialog.jl: don't show-all the passed-in widget

2000-06-28  John Harper  <john@dcs.warwick.ac.uk>

	* nokogiri-shell.jl: when flattening the group tree for the
	GNOME capplet, use a notebook widget, not a series of frames
	(less vertical height, so removes the need to make the
	top-level widget a scrolled window)

	* nokogiri-wm.jl, nokogiri-widget.jl, nokogiri-widget-test.jl,
	nokogiri-widget-dialog.jl, nokogiri-user-level.jl,
	nokogiri-slot.jl, nokogiri-shell.jl, nokogiri-main.jl.in,
	nokogiri-layout.jl, nokogiri-i18n.jl, nokogiri-group.jl,
	nokogiri-dialog.jl, nokogiri-config.jl,
	nokogiri-color-preview.jl, nokogiri-apply.jl,

	nokogiri-layouts/keymaps.jl,

	nokogiri-widgets/program.jl, nokogiri-widgets/pair.jl,
	nokogiri-widgets/match-window.jl, nokogiri-widgets/list.jl,
	nokogiri-widgets/keymap.jl, nokogiri-widgets/frame-style.jl,
	nokogiri-widgets/font.jl, nokogiri-widgets/file.jl,
	nokogiri-widgets/color.jl, nokogiri-widgets/alist.jl: 

	First check-in to main repository of new `nokogiri' config
	interface
